;************************* SUBROUTINES****************

.ORG	0X02

		IN		YL,PINB						; 1 READ HIGH BYTE OF PORT ADDRESS        7
		IN		TMPSR,SREG					; 1 SAVE STATUS REGISTER                  8
		MOV		TMPI,YL						; 1 COPY SCAN CODE TO TMPI                9
		ANDI	YL,0B00111111				; 2 PREPARING                            10
		SUBI	YL,-0X60					; 2 INTERNAL RAM                         11
		LD		BUFI,Y						; 3 LOAD CURRENT PORT DATA               13
		SBRS	TMPI,7						; 4                                    *
		AND		BUFI,COLOMN7				; 4 DATA                               * 15
		SBRS	TMPI,6						; 4 CORRECTION                         - 
		AND		BUFI,COLOMN6				; 4                                    - 17
		OUT		PORTD,BUFI					; 5 OUT CURRENT                          18
		OUT		DDRD,CONSTFF				; 5 PORT DATA                            19
		NOP									; 5 NOP1                                 20
		  NOP
NOP		
		OUT		PORTD,INTDATA				; 6 RETURN PORTD DATA                  
		OUT		DDRD,DIRD					; 6 AND MAIN DIRECTION PORTD             
		OUT		SREG,TMPSR					; 7 RETURN STATUS                       
		OUT		EIFR,CONSTFF				; 8 RESET INTF1 FLAG
		RETI								; 9 RETURN                               
