;********************** Initialization ************************


RESET:  CLI                         		; 0 DISABLING THE INTERRUPTS
		
		;LDI		BUF,1<<CLKPCE				; 1 SYSTEM 
		;OUT		CLKPR,BUF					; 1 CLOCK
		;LDI		BUF,(1<<CLKPS0);|(1<<CLKPS2); 1 IS DIVIDING
		;OUT		CLKPR,BUF					; 1 BY TWO
		
		LDI     BUF,0XDF     	  			; 2 INITIALISING OF
        OUT     SPL,BUF       				; 2 STACK POINTER

		LDI		BUF,1<<KEYMH				; 1 
		OUT		PORTD,BUF					; 1 PORT D
		SBI		DDRD,KEYMH					; 2 KLICK UP
		MOV		INTDATA,BUF					; 2 KEYMH
		CBI		DDRD,KEYMH					; 2 LINE
		LDI		BUF,(1<<MHz21)|(1<<INTFLG)|(1<<INTF12)|(1<<INTF11); 3 CONFIGURATION
		MOV		DIRD,BUF					; 3
		OUT		DDRD,DIRD					; 3 
		LDI		BUF,0XFF					; 4 PORT B
		MOV		CONSTFF,BUF					; 4
		OUT		PORTB,BUF					; 4 CONFIGURATION (PULL-UPS)
		CLR		ZERO						; 
		CLR		ZH							; 
		
		LDI		COLOMN7,0XFF
		LDI		COLOMN6,0XFF

		LDI		BUF,(1<<ISC11)				; 6 INT0 INTERRUPT BY
		OUT		MCUCR,BUF					; 6 FALLING EDGE
		LDI		BUF,(1<<INT1)				; 7 INT0 INTERRUPT
		OUT		GIMSK,BUF					; 7 ENABLE
		
		LDI		ZH,0X00						; 9 CLEAR ZH	
		LDI		BUF,0XFF					; 							
		LDI		ZL,0X60						; 0 
CLRLOOP:ST		Z+,BUF						; 0 RAM
		CPI		ZL,0XA0						; 0 INITIALISING
		BRNE	CLRLOOP						; 0 
	
								









